#include "main_window.h"
#include "ui_main_window.h"
#include "v4l2_camera_view.h"

main_window::main_window(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::main_window)
{
    led = false;
    ui->setupUi(this);
}

main_window::~main_window()
{
    delete ui;
}

void main_window::view(void)
{
    connect(ui->pushButton_LED, SIGNAL(clicked()),this, SLOT(toggleLED()));
    connect(ui->pushButton_setQVGA, SIGNAL(clicked()),this, SLOT(changeResolutionQVGA()));
    connect(ui->pushButton_setVGA, SIGNAL(clicked()),this, SLOT(changeResolutionVGA()));

    cameraView = new V4l2CameraView;
    cameraView->setDeviceName(DEV_VIDEO_PATH);
    cameraView->setFps(60);
    cameraView->setResolution(320,240);
    cameraView->start();

    ui->horizontalLayout->addWidget(cameraView);
}

void main_window::changeResolutionVGA()
{
    cameraView->stop();
    cameraView->setFps(30);
    cameraView->setResolution(640,480);

    cameraView->start();
}

void main_window::changeResolutionQVGA()
{
    cameraView->stop();
    cameraView->setFps(60);
    cameraView->setResolution(320,240);
    
    cameraView->start();
}

void main_window::toggleLED()
{
    if(led) {
        system( "echo 0 > /sys/class/leds/EXT1/brightness;"
                "echo 0 > /sys/class/leds/EXT2/brightness;"
                "echo 0 > /sys/class/leds/EXT3/brightness;"
                "echo 0 > /sys/class/leds/EXT4/brightness;"
                "echo 0 > /sys/class/leds/EXT5/brightness;"
                "echo 0 > /sys/class/leds/EXT6/brightness");
        ui->pushButton_LED->setText(tr("LED ON"));
        led = false;
    } else {
        system( "echo 1 > /sys/class/leds/EXT1/brightness;"
                "echo 1 > /sys/class/leds/EXT2/brightness;"
                "echo 1 > /sys/class/leds/EXT3/brightness;"
                "echo 1 > /sys/class/leds/EXT4/brightness;"
                "echo 1 > /sys/class/leds/EXT5/brightness;"
                "echo 1 > /sys/class/leds/EXT6/brightness");
        ui->pushButton_LED->setText(tr("LED OFF"));
        led = true;
    }
    ui->pushButton_LED->update();
}

