#ifndef V4L2CAMERA_VIEW_H
#define V4L2CAMERA_VIEW_H

#include <QWidget>
#include <QString>
#include <QTimer>
#include <QVector>
#include <QByteArray>
#include <stdint.h>
#include "config.h"

class V4l2CameraView : public QWidget
{
	Q_OBJECT
	Q_PROPERTY(QString deviceName READ deviceName WRITE setDeviceName)
	Q_PROPERTY(int fps READ fps WRITE setFps)

public:
	V4l2CameraView(QWidget *parent = NULL);
	virtual ~V4l2CameraView();

	void setDeviceName(const QString &newDeviceName);
	QString deviceName() const {return m_deviceName;}

	void setFps(int newFps);
	int fps() const {return m_fps;}

	int start();
	void stop();
	int setResolution(int width, int height);
protected:
    void paintEvent(QPaintEvent *paint);

private:
	QString m_deviceName;
	int m_fd;
	int m_cameraWidth;
	int m_cameraHeight;
	int m_numberOfBuffers;
	//QVector<void *> m_maps;
	void* m_maps[NUM_BUF];
    unsigned int m_maps_len[NUM_BUF];

	int m_fps;
	QVector<QImage> m_images;
	uchar *m_imgConvertBuf;
	int m_showing_image;
	int m_ready_image;
	QTimer *m_updateTimer;

	int openDevice();
	void closeDevice();

private slots:
	void capture();
};

#endif
